<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO;
use \Setforms2\Shared\ORM\DateTime;
use \Doctrine\ORM\EntityManager;

class Pla06800LiberacaoDeCardapioParaAgregadas extends \Teknisa\GER\Controllers\TeknisaCrud {

    private   $entityManager;
    protected $crudService;
    protected $dataSourceManager;
    protected $environment;
    protected $connection;
    protected $parameterBag;
    protected $liberacaoDeCardapioParaAgregadasService;
    protected $dataSourceParamBag;
    protected $nrlista_fili;
    protected $nrlista_filiserv;
    protected $params;
    protected $idutcardpadr;
    protected $grupoperador;
    protected $libCardapio;
    protected $PlaValidacaoCardapio;

    public function __construct($crudService, $parameterBag, $entityManager, Manager $dataSourceManager, Environment $environment, $connection, $dataSourceParamBag, $liberacaoDeCardapioParaAgregadasService, $util, $PlaValidacaoCardapio) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->entityManager = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->connection = $connection;
        $this->dataSourceParamBag = $dataSourceParamBag;
        $this->liberacaoDeCardapioParaAgregadasService = $liberacaoDeCardapioParaAgregadasService;
        $this->util = $util;
        $this->PlaValidacaoCardapio = $PlaValidacaoCardapio;
	}
	
	public function getAllServices(DTO\Request $request, DTO\Response $response) {
	    $row = $request->getRow();
	    $cdFilial = $row["CDFILIAL"];
        $allServices = $this->liberacaoDeCardapioParaAgregadasService->getAllServices($cdFilial);
        
	    $response->addDataSet(new DataSet ('listaServicos', $allServices));
	}
	
	public function handleBloqueio(DTO\Request $request, DTO\Response $response) {
	    try {
    	    $row = $request->getRow();
    	    $cdFilialCentral = $row["CDFILIAL"];
    	    $unidades = $this->liberacaoDeCardapioParaAgregadasService->getCentralEAgregadas($cdFilialCentral);
    	    
            $arrayUnidades = array_map(function($unidade) {
                return $unidade["CDFILIAL"];
            }, $unidades);
            
            if($row["CDSERVFILI"] == "" || count($row["CDSERVFILI"]) == 0) {
                $allServices = $this->liberacaoDeCardapioParaAgregadasService->getAllServices($row["CDFILIAL"]);
                $row["CDSERVFILI"] = array_map(function($servico) {
                    return $servico["CDSERVFILI"];
                }, $allServices);
            }        
            
    	    foreach($arrayUnidades as $unidade) {
                foreach($row["CDSERVFILI"] as $servico) {
                    $this->liberacaoDeCardapioParaAgregadasService->updateCardaMes($row, $unidade, $servico);
                    $this->liberacaoDeCardapioParaAgregadasService->deleteAprovCard($row, $unidade, $servico);
                }
    	    }
	        $response->addDataset(new DataSource\DataSet('RETORNO', ["SUCESSO_BLOQUEIO"]));
	    } catch (\Exception $e) {
	        $response->addDataset(new DataSource\DataSet('RETORNO', ["FALHA_OPERACAO_BLOQUEIO"]));
	    }
	}
	
	public function handleLibCard(DTO\Request $request, DTO\Response $response) {
	    try {
    	    $row = $request->getRow();
    	    $servicosComRestricao = [];
    	    
    	    $this->liberacaoDeCardapioParaAgregadasService->procedureConsumoPlanejado($row);
    	    
            if($row["CDSERVFILI"] == "" || $row["CDSERVFILI"] == "T" || count($row["CDSERVFILI"]) == 0) {
                $allServices = $this->liberacaoDeCardapioParaAgregadasService->getAllServices($row["CDFILIAL"]);
                $row["CDSERVFILI"] = array_map(function($servico) {
                    return $servico;
                }, $allServices);
            } else {
                $row["CDSERVFILI"] = $row["NMSERVICO"];
            }
            
            foreach($row["CDSERVFILI"] as $servico) {
                $params = [
                  "CDFILIAL"                        => $row["CDFILIAL"],
                  "CDSERVFILI"                      => $servico["CDSERVFILI"],
                  "IDTIPORESTRICAO"                 => 'CONTRATO',
                  "DATA_INICIAL"                    => $row["FORMATEDDTCARDAPIO"],
                  "DATA_FINAL"                      => $row["FORMATEDDTCARDAPIOEND"],
                  "PRIMEIRO_ULTIMO_DIA_SEMANA"      => $row["PRIMEIRO_ULTIMO_DIA_SEMANA"]
                ];
    	        
                //valida Restricoes Contratuais 
        	    $validacao = $this->PlaValidacaoCardapio->validaRestricoesContratuais($params);
        	    $existeRestricao = (
        	        !empty($validacao['FREQUENCIA_PRATO']) || 
        	        !empty($validacao['FREQUENCIA_GRUPO_PRATO']) || 
        	        !empty($validacao['FREQUENCIA_PRODUTO_GRUPO_PRATO']) || 
        	        !empty($validacao['RESTRICAO_PRODUTO_GRUPO_PRATO']) || 
        	        !empty($validacao['FREQUENCIA_GRUPO_PRATO_OPCAO']) || 
        	        !empty($validacao['LIMITE_PER_CAPITA_POR_SERVICO'])
        	    );
        	    
        	    $mediaEMeta = $this->liberacaoDeCardapioParaAgregadasService->retornaMediaEMeta($row, $servico["CDSERVFILI"]);
        	    
                $existeCustPadr = $this->liberacaoDeCardapioParaAgregadasService->retornCustPadr($params);
                $valorMeta = (isset($mediaEMeta[0])) ? $mediaEMeta[0]["META"] : (isset($existeCustPadr[0]) ? $existeCustPadr[0]["VRCUSTPADR"] : 0);        	    
        	    
        	    $media = (isset($mediaEMeta[0])) ? $mediaEMeta[0]["MEDIA"] : 0;
        	    $meta = $valorMeta ? $valorMeta : 0;
        	    
        	    if($existeRestricao || ($media > $meta) ||  $meta == 0 || ($media == 0 && $meta > 0) || ($media == 0 && $meta == 0)) {
                    $mediaEMeta[0]["EXISTE_RESTRICAO"] = [
                        "CDSERVFILI"        => $servico["CDSERVFILI"],
                        "NMSERVICO"         => $servico["NMSERVICO"],
                        "IDERESTRICAO"      => ($existeRestricao) ? "S" : "N",
                        "META"              => $meta,
                        "MEDIA"             => $media
                    ];
                    array_push($servicosComRestricao, $mediaEMeta[0]["EXISTE_RESTRICAO"]);
        	    }
            }
            
    	    if(count($servicosComRestricao) > 0) {
    	        return $response->addDataset(new DataSource\DataSet('SERVICO_RESTRICAO', $servicosComRestricao));
    	    }
            
            //Validação de pratos locais
            $cdServicos = array_map(function($servico) {
                    return $servico["CDSERVFILI"];
            }, $row["CDSERVFILI"]);
            $listaServicos = $this->util->insertLista($cdServicos);
            $params = [
                "P_CDFILIAL"    => $row["CDFILIAL"],
                "P_NRLISTA"     => $listaServicos,
                "P_DTMESCARD"   => $row["FORMATEDDTCARDAPIO"]
            ];
            
            $this->liberacaoDeCardapioParaAgregadasService->procedureVerificaCardPadrao($params);
            
            $pratosInconsistentes = $this->liberacaoDeCardapioParaAgregadasService->retornaPratosInconsistentes($params);
            
            if(count($pratosInconsistentes) > 0) {
                return $response->addDataset(new DataSource\DataSet('PRATO_SEM_FILIAL_AGREGADA_DEST', $pratosInconsistentes));
            }
            
            //Liberação cardapio
            $listaServicos = $this->util->insertLista($cdServicos);
            $paramslibeCard = [
                "P_CDFILIAL"    => $row["CDFILIAL"],
                "P_NRLISTA"     => $listaServicos,
                "P_CDOPERADOR"  => $this->environment->getCdOperador(),
                "P_DTMESCARD"   => $row["FORMATEDDTCARDAPIO"]                
            ];
            
            $this->liberacaoDeCardapioParaAgregadasService->procedureLiberaCardPadrao($paramslibeCard);
            
            $response->addDataset(new DataSource\DataSet('SUCESSO_LIB_CARD', ['SUCESSO_LIB_CARD']));
	        
	    } catch(\Exception $e) {
	        $response->addDataset(new DataSource\DataSet('RETORNO', $e));
	    }
	}
	
	public function liberacaoCardapio(DTO\Request $request, DTO\Response $response) {
	    try {
    	    $row = $request->getRow();
    	    
            if($row["CDSERVFILI"] == "" || $row["CDSERVFILI"] == "T" || count($row["CDSERVFILI"]) == 0) {
                $allServices = $this->liberacaoDeCardapioParaAgregadasService->getAllServices($row["CDFILIAL"]);
                $row["CDSERVFILI"] = array_map(function($servico) {
                    return $servico;
                }, $allServices);
            } else {
                $row["CDSERVFILI"] = $row["NMSERVICO"];
            }    
    	    
    	    $cdServicos = array_map(function($servico) {
    	        return $servico["CDSERVFILI"];
    	    },$row["CDSERVFILI"]);
    	    
    	    $listaServicos = $this->util->insertLista($cdServicos);
    	    $paramslibeCard = [
                "P_CDFILIAL"    => $row["CDFILIAL"],
                "P_NRLISTA"     => $listaServicos,
                "P_CDOPERADOR"  => $this->environment->getCdOperador(),
                "P_DTMESCARD"   => $row["FORMATEDDTCARDAPIO"]       	        
    	   ];
    	    
    	    $this->liberacaoDeCardapioParaAgregadasService->procedureLiberaCardPadrao($paramslibeCard);
    	    
    	    return $response->addDataset(new DataSource\DataSet('SUCESSO_LIB_CARD', ['SUCESSO_LIB_CARD']));
	        
	    } catch(\Exception $e) {
	        return $response->addDataset(new DataSource\DataSet('FALHA_LIBERACAO_CARDAPIO', $e));
	    }
	}
}