<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Report\ReportService;

class Pla11800ReplicacaoMensalDoCardapioReportController extends \Zeedhi\Framework\Controller\Report {
    protected $environment;
    protected $birtStrategy;
    protected $entityManager;

    protected $reportMapping = array (
        'PLA11800' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'P_LISTAERROS' => 'P_LISTAERROS',
                'P_NRORG' => 'P_NRORG',
                'P_IDIOMA' => 'P_IDIOMA'
            ),
        )
    );
    
    public function __construct($reportService, $entityManager, $environment, $birtStrategy) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->birtStrategy = $birtStrategy;
        $this->reportService = $reportService;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat($row['QR2TYPE']);
    }
}